
box={

	h=100, -- heigth
	w=100, --width
	d=100, --depth
	
	cx=100, --center_x
	cy=100, --center_y
	
	x_dx=0, --distance to right surface
	x_dy=0, --distance to right surface
	
	--y_dx=0, -- not used
	y_dy=0, -- distance to upper surface
	
	z_dx=0, --distance to front surface
	z_dy=0, --distance to front surface
	
	rx=0, --box's rotation, additional to axis
	ry=0  --box's rotation, additional to axis
	
}


function box.load(box,axis)
	
	--experimental version to define size of box based on images (skins); WIP
	
		box.face=love.graphics.newImage('face.PNG')

		local face=box.face
		local lgd=love.graphics.draw
		--love.graphics.draw( drawable, x, y, r, sx, sy, ox, oy, kx, ky )
		--lgd(face,cx,cy,0,axis.x_sx,axis.x_sy,0,0,0,0)
		
		
		local x=box.w/2
		local y=box.h/2
		local z=box.d/2
		
		box.x=x
		box.y=y
		box.z=z
		
		box.x_dx=x*axis.x_sx
		box.x_dy=x*axis.x_sy
		box.y_dy=y*axis.y_sy
		box.z_dx=z*axis.z_sx
		box.z_dy=z*axis.z_sy

	function box.update(box,axis)

		local pi=math.pi
		
	--remember to bount box rotation between 0 and 2 	
		--(WIP b/c not used yet)
		
	----

		local rx=(box.rx+axis.rx)*pi
		local ry=(box.ry+axis.ry)*pi
		
		local x=box.w/2
		local y=box.h/2
		local z=box.d/2
		
		box.x=x
		box.y=y
		box.z=z

		--[[
		local x_dx=x*cos(ry)
		local x_dy=x*sin(rx)*sin(ry)*-1
		--local y_dx=
		local y_dy=h*cos(rx)
		local z_dx=z*sin(ry)
		local z_dy=z*sin(rx)*cos(ry)
		--]]
		
		box.x_dx=x*axis.x_sx
		box.x_dy=x*axis.x_sy
		box.y_dy=y*axis.y_sy
		box.z_dx=z*axis.z_sx
		box.z_dy=z*axis.z_sy
				
	end
		
	-- intermediate draw funcitons
	
	function box.drawSide(box,string,r,g,b)
	
		if r==nil then r=100 end
		if g==nil then g=100 end
		if b==nil then b=150 end

		local lgp=love.graphics.polygon	
		local lgc=love.graphics.setColor
		
		local px,py -- center point of surface
		local p1x, p1y, p2x, p2y, p3x, p3y, p4x, p4y --vertices fo surface
		local cx=box.cx
		local cy=box.cy
		local x_dx=box.x_dx
		local x_dy=box.x_dy
		local y_dy=box.y_dy
		local z_dx=box.z_dx
		local z_dy=box.z_dy

				
		if string=='front' then 
		
			px=cx+z_dx
			py=cy+z_dy
			
			p1x=px+x_dx
			p1y=py+x_dy+y_dy --lower right
			
			p2x=px+x_dx
			p2y=py+x_dy-y_dy -- upper right
			
			p3x=px-x_dx
			p3y=py-x_dy-y_dy --upper left
			
			p4x=px-x_dx
			p4y=py-x_dy+y_dy --lower left
			
			r,g,b=0,200,0
			lgc(r,g,b) 
			lgp('fill', p1x, p1y, p2x, p2y, p3x, p3y, p4x, p4y)

			--front face
			lgd(face,p3x,p3y,0,axis.x_sx,axis.y_sy,0,0,0,axis.x_sy/axis.y_sy)--*axis.x_sy)

			lgc(255,255,255) 
			lgp('line', p1x, p1y, p2x, p2y, p3x, p3y, p4x, p4y)			
			

			
		elseif string=='back' then
		
			px=cx-z_dx
			py=cy-z_dy
			
			p1x=px+x_dx
			p1y=py+x_dy+y_dy --lower right
			
			p2x=px+x_dx
			p2y=py+x_dy-y_dy -- upper right
			
			p3x=px-x_dx
			p3y=py-x_dy-y_dy --upper left
			
			p4x=px-x_dx
			p4y=py-x_dy+y_dy --lower left
			
			r,g,b=200,0,0
			lgc(r,g,b) 
			lgp('fill', p1x, p1y, p2x, p2y, p3x, p3y, p4x, p4y)

			--back face
			lgd(face,p2x,p2y,0,-axis.x_sx,axis.y_sy,0,0,0,-axis.x_sy/axis.y_sy)--*axis.x_sy)			
			
			lgc(255,255,255) 
			lgp('line', p1x, p1y, p2x, p2y, p3x, p3y, p4x, p4y)					
			
		elseif string=='right' then
		
			px=cx+x_dx
			py=cy+x_dy
			
			p1x=px+z_dx
			p1y=py+z_dy+y_dy -- lower front 

			p2x=px+z_dx
			p2y=py+z_dy-y_dy -- upper front

			p3x=px-z_dx
			p3y=py-z_dy-y_dy -- upper back		
			
			p4x=px-z_dx
			p4y=py-z_dy+y_dy -- lower back

			r,g,b=0,0,200
			lgc(r,g,b) 
			lgp('fill', p1x, p1y, p2x, p2y, p3x, p3y, p4x, p4y)

			--right face
			lgd(face,p2x,p2y,0,-axis.z_sx,axis.y_sy,0,0,0,-axis.z_sy/axis.y_sy)--*axis.x_sy)
			
			lgc(255,255,255) 
			lgp('line', p1x, p1y, p2x, p2y, p3x, p3y, p4x, p4y)					
			
			elseif string=='left' then
			px=cx-x_dx
			py=cy-x_dy
			
			p1x=px+z_dx
			p1y=py+z_dy+y_dy -- lower front 

			p2x=px+z_dx
			p2y=py+z_dy-y_dy -- upper front

			p3x=px-z_dx
			p3y=py-z_dy-y_dy -- upper back		
			
			p4x=px-z_dx
			p4y=py-z_dy+y_dy -- lower back
			
			r,g,b=200,200,0
			lgc(r,g,b) 
			lgp('fill', p1x, p1y, p2x, p2y, p3x, p3y, p4x, p4y)

			--right face
			lgd(face,p3x,p3y,0,axis.z_sx,axis.y_sy,0,0,0,axis.z_sy/axis.y_sy)--*axis.x_sy)
			
			lgc(255,255,255) 
			lgp('line', p1x, p1y, p2x, p2y, p3x, p3y, p4x, p4y)					
			
		elseif string=='down' then
			px=cx--+y_dy
			py=cy+y_dy
			
			p1x=px+x_dx+z_dx
			p1y=py+x_dy+z_dy -- forward right
			
			p2x=px+x_dx-z_dx
			p2y=py+x_dy-z_dy -- backward right
			
			p3x=px-x_dx-z_dx
			p3y=py-x_dy-z_dy -- backward left			
			
			p4x=px-x_dx+z_dx
			p4y=py-x_dy+z_dy -- forward left
			
			r,g,b=255,100,0
			lgc(r,g,b) 
			lgp('fill', p1x, p1y, p2x, p2y, p3x, p3y, p4x, p4y)

			--down/bottom face
			--h is the line that's 90 deg from the x axis line, visually
			local hr=axis.xr+0.5*math.pi-axis.zr
			local hl=axis.zl*math.cos(hr)
			local kx=axis.zl*math.sin(hr)/axis.xl
--[[
			lgd(face,p2x,p2y,axis.xr,-axis.xl,
			hl,
			0,0, --ox,oy
			-kx) --kx				--]]

			lgd(face,p4x,p4y,axis.xr,axis.xl,
			-hl,
			0,0, --ox,oy
			-kx) --kx						

			lgc(255,255,255) 
			lgp('line', p1x, p1y, p2x, p2y, p3x, p3y, p4x, p4y)					

		elseif string=='up' then
			px=cx-- -y_dx
			py=cy-y_dy

			p1x=px+x_dx+z_dx
			p1y=py+x_dy+z_dy -- forward right
			
			p2x=px+x_dx-z_dx
			p2y=py+x_dy-z_dy -- backward right
			
			p3x=px-x_dx-z_dx
			p3y=py-x_dy-z_dy -- backward left	
			
			p4x=px-x_dx+z_dx
			p4y=py-x_dy+z_dy -- forward left
		
			r,g,b=200,200,200
			lgc(r,g,b) 
			lgp('fill', p1x, p1y, p2x, p2y, p3x, p3y, p4x, p4y)

			--top face
			--h is the line that's 90 deg from the x axis line, visually
			local hr=axis.xr+0.5*math.pi-axis.zr
			local hl=axis.zl*math.cos(hr)
			local kx=axis.zl*math.sin(hr)/axis.xl

			lgd(face,p3x,p3y,axis.xr,axis.xl,
			hl,
			0,0, --ox,oy
			kx) --kx			
			
			lgc(255,255,255) 
			lgp('line', p1x, p1y, p2x, p2y, p3x, p3y, p4x, p4y)				
		
		end
		
	end
	

	
		
	function box.draw(box)
	
		local rx=box.rx+axis.rx
		local ry=box.ry+axis.ry
	
	--!! draw differently based on angle

		local side=box.drawSide

		local c=200
		local d=100
		
		local r,g,b=0,0,0 
		if rx<0.5 and ry<0.5 then --
			--local r,g,b=c,0,0
			side(box,'down',r,g,b)
			side(box,'right',r,g,b)
			side(box,'back',r,g,b)
			side(box,'left',r,g,b)
			side(box,'up',r,g,b)
			side(box,'front',r,g,b)

		elseif rx<0.5 and ry<1 then --
			--local r,g,b=0,c,0		
			side(box,'down',r,g,b)
			side(box,'right',r,g,b)
			side(box,'front',r,g,b)
			side(box,'back',r,g,b)
			side(box,'left',r,g,b)
			side(box,'up',r,g,b)

		elseif rx<0.5 and ry<1.5 then --		
			--local r,g,b=0,0,c		
			side(box,'down',r,g,b)
			side(box,'front',r,g,b)
			side(box,'left',r,g,b)
			side(box,'right',r,g,b)
			side(box,'up',r,g,b)
			side(box,'back',r,g,b)

		elseif rx<0.5 and ry<2 then --
			--local r,g,b=c,c,0		
			side(box,'down',r,g,b)
			side(box,'left',r,g,b)
			side(box,'front',r,g,b)
			side(box,'right',r,g,b)
			--side(box,'back',r,g,b)
			side(box,'up',r,g,b)
		
		elseif rx<1 and ry<0.5 then--
			--local r,g,b=c,0,c		
			side(box,'down',r,g,b)
			side(box,'front',r,g,b)
			side(box,'left',r,g,b)
			side(box,'right',r,g,b)
			side(box,'back',r,g,b)
			side(box,'up',r,g,b)
	
		elseif rx<1 and ry<1 then--
			--local r,g,b=0,c,c		
			side(box,'down',r,g,b)
			side(box,'back',r,g,b)
			side(box,'left',r,g,b)
			r,g,b=25,25,25
			side(box,'right',r,g,b)
			side(box,'front',r,g,b)
			side(box,'up',r,g,b)
	
		elseif rx<1 and ry<1.5 then	--,,
			--local r,g,b=c,c,c		
			side(box,'down',r,g,b)
			side(box,'back',r,g,b)
			side(box,'right',r,g,b)
			side(box,'front',r,g,b)
			side(box,'left',r,g,b)
			side(box,'up',r,g,b)

		elseif rx<1 and ry<2 then	--	
			--local r,g,b=0,0,0		
			side(box,'down',r,g,b)
			side(box,'right',r,g,b)
			side(box,'front',r,g,b)
			side(box,'back',r,g,b)
			side(box,'up',r,g,b)
			side(box,'left',r,g,b)

		elseif rx<1.5 and ry<0.5 then 
			--local r,g,b=d,0,0		
			side(box,'up',r,g,b)
			side(box,'front',r,g,b)
			side(box,'left',r,g,b)
			side(box,'back',r,g,b)
			side(box,'right',r,g,b)
			side(box,'down',r,g,b)
	
		elseif rx<1.5 and ry<1 then 
			--local r,g,b=0,d,0		
			side(box,'up',r,g,b)
			side(box,'back',r,g,b)
			side(box,'left',r,g,b)
			side(box,'right',r,g,b)
			side(box,'front',r,g,b)
			side(box,'down',r,g,b)
	
		elseif rx<1.5 and ry<1.5 then	
			--local r,g,b=0,0,d		
			side(box,'up',r,g,b)
			side(box,'back',r,g,b)
			side(box,'right',r,g,b)
			side(box,'left',r,g,b)
			side(box,'front',r,g,b)
			side(box,'down',r,g,b)

		elseif rx<1.5 and ry<2 then
			--local r,g,b=d,d,0		
			side(box,'up',r,g,b)
			side(box,'front',r,g,b)
			side(box,'right',r,g,b)
			side(box,'left',r,g,b)
			side(box,'back',r,g,b)
			side(box,'down',r,g,b)

		elseif rx<2 and ry<0.5 then
			--local r,g,b=0,d,d	
			side(box,'up',r,g,b)
			side(box,'back',r,g,b)
			side(box,'right',r,g,b)
			side(box,'left',r,g,b)
			side(box,'front',r,g,b)
			side(box,'down',r,g,b)

		elseif rx<2 and ry<1 then
			--local r,g,b=d,d,d		
			side(box,'up',r,g,b)
			side(box,'right',r,g,b)
			side(box,'front',r,g,b)
			side(box,'back',r,g,b)
			side(box,'left',r,g,b)
			side(box,'down',r,g,b)
		
		elseif rx<2 and ry<1.5 then	
			--local r,g,b=c,d,0		
			side(box,'up',r,g,b)
			side(box,'front',r,g,b)
			side(box,'left',r,g,b)
			side(box,'right',r,g,b)
			side(box,'back',r,g,b)
			side(box,'down',r,g,b)

		elseif rx<2 and ry<2 then
			local r,g,b=d,c,0		
			side(box,'up',r,g,b)
			side(box,'back',r,g,b)
			side(box,'left',r,g,b)
			side(box,'right',r,g,b)
			side(box,'front',r,g,b)
			side(box,'down',r,g,b)

		end
		
	end

end